package com.baicizhan.client.business.util

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract

/**
 * Created by Jacee.
 * Date: 2020.05.27
 */

inline fun <R> String?.available(block: (String) -> R?): R? {
    contract {
        callsInPlace(block, InvocationKind.EXACTLY_ONCE)
    }
    return if (!isNullOrEmpty()) {
        block(this)
    } else null
}

fun String?.availableWith(default: String): String {
    return available {
        it
    } ?: default.available {
        it
    } ?: run {
        check(default.isNotEmpty())
        ""
    }
}

infix fun <T> T?.anyOf(array: Array<T>): Boolean {
    if (this == null) {
        return false
    }
    array.forEach {
        if (this == it) {
            return true
        }
    }
    return false
}